# -*- coding: utf-8 -*-
#-----------------------------------------------------------------------------
# Copyright (c) 2012, Techunits
#
# Distributed under the terms of the MIT License
#-----------------------------------------------------------------------------

import logging
import urllib
import urllib2
import json

from mahs.exception import *
#from lxml import etree

log = logging.getLogger('mahs')

class MaHSAPI(object):
    
    def __init__(self, apiUrl, apiKey, apiSecretKey):
        self.currentUserAgent = 'MaHS-Python-Client-1.0.1'
        
        if not apiUrl:
            raise MaHSInitializationError('API URL not specified.')
        else:
            self.apiUrl = apiUrl

        if not apiKey:
            raise MaHSInitializationError('API Key not specified.')
        else:
            self.apiKey = apiKey

        if not apiSecretKey:
            raise MaHSInitializationError('Secret Key not specified.')
        else:
            self.apiSecretKey = apiSecretKey


    # show curent object for debug purposes
    def printObjectDebugInfo(self):
        print(self)
        quit()
  
  
    def setQuery(self, queryObject):
        self.apiUrl += '/query'
        self.queryObject = queryObject
  
    
    def executeCall(self):
        if self.queryObject is not None:
            httpGetData = urllib.urlencode({
                'apiKey': self.apiKey,
                'apiSecret': self.apiSecretKey,
                'indexBase': self.queryObject.searchIndex,
                'keyword': self.queryObject.keyword,
                'sortMode': self.queryObject.sortMode,
                'matchMode': self.queryObject.matchMode,
            })
            httpHeaders = {
                'User-Agent' :  self.currentUserAgent
            }
            self.apiUrl += '?'+httpGetData
            requestObject = urllib2.Request(self.apiUrl, None, httpHeaders)
            try:
                response = urllib2.urlopen(requestObject)
                responseObj = json.loads(response.read())
                return responseObj;
            except urllib2.HTTPError as e:
                print('Invalid API url. HTTP Error code: ' + str(e.code))
                
            
        else:
            raise MaHSRequestError('Missing QueryObject. Not yet implemented')
        
        
        
        
    
    

