# -*- coding: utf-8 -*-
#-----------------------------------------------------------------------------
# Copyright (c) 2012, Techunits
#
# Distributed under the terms of the MIT License
#-----------------------------------------------------------------------------

class MaHSError(StandardError):

    @property
    def read(self):
        '''
        Returns the read function of the first readable argument in this
        exception.
        '''
        if self.args:
            for arg in self.args:
                if hasattr(arg, 'read'):
                    if callable(arg.read):
                        return arg.read
                    else:
                        return lambda: arg.read


class MaHSInitializationError(MaHSError):
    pass

# COMM ERRORS
class MaHSIOError(MaHSError):
    pass

# REQUEST ERRORS
class MaHSRequestError(MaHSIOError):
    pass

# RESPONSE ERROR
class MaHSResponseError(MaHSIOError):
    pass

class MaHSMethodNotImplementedError(MaHSRequestError):
    pass


